CoCoA-5 - Design #990
CoCoA-5 distribution: tidying
05 Dec 2016 14:50 - John Abbott

Status: Closed Start date: 05 Dec 2016
Priority: Normal Due date:

Assignee: John Abbott % Done: 100%
Category: Release Estimated time: 5.01 hours
Target version: CoCoA-5.3.0 Spent time: 5.00 hours
Description

| have had a quick look at the files in the distribution of CoCoA-5.1.5, and | think some tidying is needed.

e Several files have "surprising" permissions (e.g. all the packages should have permission -rw-r--r--)
¢ do we need to make public all the files in CoCoAManual?

Related issues:

Related to CoCoALib - Bug #1264: Remove unnecessary files before making CoCoA... Closed 26 Mar 2019
Related to CoCoA-5 - Design #1453: Use symbolic links for release files New 30 Apr 2020
History

#1 - 05 Dec 2016 14:55 - John Abbott
- Status changed from New to In Progress

- % Done changed from 0 to 10

| have noticed that several files inside our source tree have wrong permissions:

e all source.C files should have permission 644 (equiv. -rw-r--r--)
e all directories should have permission 755 (equiv. -rwxr-xr-x)

e all packages should have permission 644
¢ all tests should have permission 644

| wonder how these weird permissions came to be set.
I think | even saw one file which was setgid (that really should not happen).

#2 - 05 Dec 2016 15:01 - John Abbott

| am trying to write a make install target for CoCoA-5, and this involves copying the manual.
Rather than blindly copy the contents of the script release-common, | wanted to write it explicitly myself.
| think there is some "junk" in what we distribute: running Is - on the directory cocoa-5.1.5/CoCoAManual/ produces:

16:44 aux

16:44 CoCoAHelp.xml

16:44 CoCoAManual.pdf

16:44 CoCoATranslationTable.html
16:44 html

16:44 README

16:44 wordlist.txt

drwxrwxr—-x jabbott wbs 109 Nov
jabbott wbs 705452 Nov
Jjabbott wbs 2316319 Nov

5
—rwxr——-r—— 1
1

—-rwxr—-—-r—— 1 jabbott wbs 54890 Nov
2
1
1

—IW—XrW—-Ir——

drwxrwxr-x jabbott wbs 24576 Nov
jabbott wbs 2303 Nov
jabbott wbs 7094 Nov

—IW—XrW—-Ir——

N B N BN N |

—IW—Irw—-r——

| imagine that README is not needed; all the permissions look wrong to me!
| am not sure about the contents of aux:
ArwxXrwxr—x 16:44 CVS

16:44 GUI-extra-files
16:44 GUI_help.xsl
16:44 saxon.jar

16:44 TeX-extra-files

16:44 TeX.xsl

jabbott wbs 60 Nov
jabbott wbs 4096 Nov
jabbott wbs 23188 Nov
jabbott wbs 630144 Nov
jabbott wbs 33 Nov
jabbott wbs 8451 Nov

drwxrwxr—-x
—rW-rw-r—-—
—TWXTWXT—X

drwxrwxr—-x

R Wk R WwN
o = = =9 =9 =F

—YW—Irw—Ir——

Surely CVS should not be there; perhaps none of the TeX stuff either?
What about saxon.jar?

#3 - 07 Dec 2016 07:53 - Anna Maria Bigatti
John Abbott wrote:

| imagine that README is not needed; all the permissions look wrong to me!

README should be there (maybe | should improve it) because it explains how to add new entries in the manual (if a user wants to make a new
package)

| am not sure about the contents of aux:

aux should not be distributed.

#4 - 13 Dec 2016 16:53 - John Abbott

I think it is probably better to copy explicitly the files we want in the distribution, rather than copy everything and then delete the ones we do not want
in the distribution. It will probably take more commands to make the copy the way | propose, but it should be easier for anyone reading the code to
understand what we want to be in the distribution.

Note that | mean to allow copying *.html so that all HTML files are copied:; it is not necessary (nor desirable) to name them one-by-one.

#5 - 15 Feb 2020 23:41 - John Abbott
- Target version changed from CoCoA-5.?.? to CoCoA-5.3.0
- % Done changed from 10 to 20

| have unpacked the latest targz "binary" file for CoCoA-5.2.9.
Some files erroneously have "execute" permission:

$ find . -type f -perm /011 -exec 1ls -1 {} \;

-rwxr—-xr—-x 1 jabbott jabbott 3908 Feb 15 11:57 ./packages/BinRepr.cpkg5b

jabbott jabbott 3072 Feb 15 11:57 ./packages/sppoly.cpkg5

Jabbott jabbott 38717568 Feb 15 11:57 ./bin/CoCoAlnterpreter

jabbott jabbott 3279 Feb 15 11:57 ./cocoab

jabbott jabbott 24007 Feb 15 11:57 ./CoCoAManual/aux/TeX-extra-files/mybook.cls
Jabbott jabbott 4407 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/history.html
jabbott jabbott 2596 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/notes.html
jabbott jabbott 1843 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/index.html

—rwxr-xr-x 1
1
1
1
1
1
1

—rwxr-xr-x 1 jabbott Jjabbott 4196 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/bugs.html
1
1
1
1
1
1
1

—IrWXT—XIr—X
—IrWXIr—Xr—X
—TWXT—XTr—-X
—IrWXT—XIr—X
—IrWXIr—-Xr—X
—TWXT—XTr—-X
—IrWXr—Xr—x jabbott jabbott 3102 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/uih.html
jabbott jabbott 6098 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/completion.html
Jabbott jabbott 8982 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/shortcuts.html
jabbott jabbott 4606 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/toolbars.html
jabbott jabbott 9263 Feb 15 11:57 ./CoCoAManual/aux/GUI-extra-files/menus.html
Jabbott jabbott 630144 Feb 15 11:57 ./CoCoAManual/aux/saxon.Jjar

jabbott jabbott 1795 Feb 15 11:57 ./emacs/ConfigEmacs.sh

—FWXr—Xr—x
“IWXr—Xr—X
—“IWXr—Xr—X
—FWXr—Xr—x
“IWXr—Xr—X
—“IWXr—Xr—X

| found no files with suspect write permission. Anyway, it would be good to run the "FIX_PERMS" script which makes the file permissions safer
before making the targz file.

#6 - 15 Feb 2020 23:42 - John Abbott
- Related to Bug #1264: Remove unnecessary files before making CoCoALib release TGZ files added

#7 - 03 Mar 2020 22:14 - John Abbott

Maybe the commands in the script FIX_PERMS.sh can be put into a shell function in release-common.sh?

#8 - 09 Mar 2020 11:31 - Anna Maria Bigatti
John Abbott wrote:

Maybe the commands in the script FIX_PERMS.sh can be put into a shell function in release-common.sh?

working on it
#9 - 09 Mar 2020 13:51 - Anna Maria Bigatti
- % Done changed from 20 to 80

Anna Maria Bigatti wrote:
John Abbott wrote:

Maybe the commands in the script FIX_PERMS.sh can be put into a shell function in release-common.sh?

working on it

Done, checked in. FIX_PERMS_COCOAS5.sh.

#10 - 09 Mar 2020 15:56 - John Abbott

I have just checked the contents of cocoa-5.3-mac.tgz.

There are three files whose names begin with dot-underscore, and one file called lconXYZ (where | am not sure what XYZ is).
Hope that is OK.
File permissions seem sane.

#11 - 20 Mar 2020 13:21 - John Abbott
- Status changed from In Progress to Feedback

- % Done changed from 80 to 90

NOTE: the linux version unpacks into cocoa-5.3.0/ whereas the Mac version unpacks into CoCoA-5.3. Intentional?
Linux version seems to be clean.
Mac version is OK, but:

e strange executables with DOT-UNDERSCORE prefix (cocoab, emacs (dir!), emacs/ConfigEmacs.command)
e two futher DOT-UNDERSCORE files: Icon (and unprintable char), and CoCoAManual.pdf in CoCoAManual/

#12 - 20 Mar 2020 18:00 - Anna Maria Bigatti
John Abbott wrote:

NOTE: the linux version unpacks into cocoa-5.3.0/ whereas the Mac version unpacks into CoCoA-5.3. Intentional?
No :-(
But now | wonder whether it'd be better to have 5.3.0...

Linux version seems to be clean.
Mac version is OK, but:

e strange executables with DOT-UNDERSCORE prefix (cocoab, emacs (dir!), emacs/ConfigEmacs.command)
¢ two futher DOT-UNDERSCORE files: Icon (and unprintable char), and CoCoAManual.pdf in CoCoAManual/

| cannot see those files, but | believe they are related to the icons, and coloured bullets | set in the release process.

#13 - 26 Mar 2020 11:38 - John Abbott

Here is a quick summary of what | think the installation "script" for CoCoALib does:

e create new dir with name like /usr/local/include/CoCoA-0.99700 and put the header files in there

e create a symbolic link so that /usr/local/include/CoCoA actually "points to" the directory created above

e put the library in /usr/local/lib/libcocoa-0.99700.a

¢ create a symbolic link so that /usr/local/lib/libcocoa.a "points to" the latest library
An advantage of this approach is that if installation goes wrong (but not horribly wrong, like when | wiped out half of /usr),
then a "skilled" use can simply move the symbolic links to point back to the previous installation. Note that the previous
installation is not removed.
| think doing something similar could be reasonable for CoCoA-5 too.

e all files for the distribution are put into cocoa-5.3.0

¢ then we make a symbolic link so that cocoa-5 (or even just cocoa???) points to the latest version

e any older installations are not removed (but perhaps an informative message about them could be printed?)

What do you think?

#14 - 26 Mar 2020 11:40 - John Abbott
It's a bit late to make a change for the current version, but we could do it for the next release...
| suggest postponing this issue to have enough time to discuss (& implement if appropriate).

#15 - 30 Apr 2020 15:06 - John Abbott
- Related to Design #1453: Use symbolic links for release files added

#16 - 30 Apr 2020 15:10 - John Abbott

- Status changed from Feedback to Closed
- Assignee set to John Abbott

- % Done changed from 90 to 100

- Estimated time set to 5.01 h

The main part of this issue has been resolved adequately.
The idea in comment 13 has been moved to a new issue #1453.

Closing.
